#ifndef MOVING_ACTOR_H
#define MOVING_ACTOR_H

#include "Actor.h"
#include <SDL3/SDL_rect.h>
#include <memory>
#include "../Components/MoveComponent.h"
#include "../DataStructures/NormalizedDirection.h"

class MovingActor : public Actor
{
public:
    ~MovingActor() = default;
    //void Update(float deltaTime) override {};
    void Update(float deltaTime) {m_MoveComponent->Update(deltaTime);};
    void SetDirection(NormalizedDirection direction) {m_MoveComponent->SetDirection(direction);}

    friend class ActorFactory;
protected:
    MovingActor(SDL_FRect hitbox);
    //MovingActor(const MovingActor&) = default;
    //MovingActor& operator=(const MovingActor&) = default;
    void Init() override;

    //std::unique_ptr<MoveComponent> m_MoveComponent;
    std::shared_ptr<MoveComponent> m_MoveComponent;

};

#endif