#include "MoveComponent.h"
#include <math.h>


void MoveComponent::Update(float deltaTime)
{
    float distance = m_Speed * deltaTime;
    if(m_ForcedDistance > 0)
    {
        if(m_ForcedDistance < distance)
        {
            distance = m_ForcedDistance;
            m_ForcedDistance = 0;
            //TODO: get normal speed value
        }
        else
        {
            m_ForcedDistance -= distance;
        }
    }
    Vector2D velocity = m_Direction.GetDirection() * distance;

    //TODO: collision
    bool collision = false;
    if(collision)
    {
        m_ForcedDistance = 0;
    }
    else
    {
        m_Actor.lock()->MoveBy(velocity);
    }
    if(m_ForcedDistance == 0)
    {
        //delete direction
        m_Direction = NormalizedDirection();
    }
}

void MoveComponent::SetForced(const NormalizedDirection & direction, float speed, float distance)
{
    m_Direction = direction;
    m_Speed = speed;
    m_ForcedDistance = distance;
}

void MoveComponent::SetDirection(const NormalizedDirection & direction)
{
    //only allow setting a direction if not being kicked
    if(m_ForcedDistance == 0)
    {
        m_Direction = direction;
    }
}

void MoveComponent::SetSpeed(float speed)
{
    //only allow setting a speed if not being kicked
    if(m_ForcedDistance == 0)
    {
        m_Speed = speed;
    }
}
