#include "NormalizedDirection.h"
#include <math.h>

NormalizedDirection::NormalizedDirection(float x, float y, bool isNormalized)
{
    if(isNormalized || (x == 0 && y == 0))
    {
        m_Direction.x = x;
        m_Direction.y = y;
    }
    else
    {
        float normalizeValue = 1 / sqrt(pow(x,2) + pow(y,2));
        m_Direction.x = x * normalizeValue;
        m_Direction.y = y * normalizeValue;
    }
}

NormalizedDirection::NormalizedDirection(SDL_FPoint direction, bool isNormalized)
{
    NormalizedDirection(direction.x, direction.y, isNormalized);
}

NormalizedDirection::NormalizedDirection(Vector2D direction, bool isNormalized)
{
    NormalizedDirection(direction.x, direction.y, isNormalized);
}